diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.33/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.32/src/wifi/test/spectrum-wifi-phy-test.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/test/spectrum-wifi-phy-test.cc	2021-01-09 10:19:23.000000000 -0800
@@ -16,18 +16,21 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
-#include "ns3/spectrum-phy.h"
 #include "ns3/test.h"
+#include "ns3/constant-position-mobility-model.h"
 #include "ns3/spectrum-wifi-helper.h"
 #include "ns3/wifi-spectrum-value-helper.h"
+#include "ns3/multi-model-spectrum-channel.h"
 #include "ns3/spectrum-wifi-phy.h"
 #include "ns3/nist-error-rate-model.h"
 #include "ns3/wifi-mac-header.h"
 #include "ns3/wifi-spectrum-signal-parameters.h"
 #include "ns3/wifi-phy-listener.h"
 #include "ns3/log.h"
+#include "ns3/wifi-net-device.h"
 #include "ns3/wifi-psdu.h"
 #include "ns3/wifi-ppdu.h"
+#include "ns3/wifi-utils.h"
 
 using namespace ns3;
 
@@ -38,6 +41,13 @@
 static const uint16_t CHANNEL_WIDTH = 20; // MHz
 static const uint16_t GUARD_WIDTH = CHANNEL_WIDTH; // MHz (expanded to channel width to model spectrum mask)
 
+class ExtSpectrumWifiPhy : public SpectrumWifiPhy
+{
+public:
+  using SpectrumWifiPhy::SpectrumWifiPhy;
+  using SpectrumWifiPhy::GetBand;
+};
+
 /**
  * \ingroup wifi-test
  * \ingroup tests
@@ -105,7 +115,7 @@
 Ptr<SpectrumSignalParameters>
 SpectrumWifiPhyBasicTest::MakeSignal (double txPowerWatts)
 {
-  WifiTxVector txVector = WifiTxVector (WifiPhy::GetOfdmRate6Mbps (), 0, WIFI_PREAMBLE_LONG, 800, 1, 1, 0, 20, false, false);
+  WifiTxVector txVector = WifiTxVector (WifiPhy::GetOfdmRate6Mbps (), 0, WIFI_PREAMBLE_LONG, 800, 1, 1, 0, 20, false);
 
   Ptr<Packet> pkt = Create<Packet> (1000);
   WifiMacHeader hdr;
@@ -309,6 +319,318 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
+ * \brief Spectrum Wifi Phy Filter Test
+ */
+class SpectrumWifiPhyFilterTest : public TestCase
+{
+public:
+  SpectrumWifiPhyFilterTest ();
+  /**
+   * Constructor
+   *
+   * \param name reference name
+   */
+  SpectrumWifiPhyFilterTest (std::string name);
+  virtual ~SpectrumWifiPhyFilterTest ();
+
+private:
+  virtual void DoSetup (void);
+  virtual void DoRun (void);
+
+  /**
+   * Run one function
+   */
+  void RunOne ();
+
+  /**
+   * Send PPDU function
+   */
+  void SendPpdu (void);
+
+  /**
+   * Callback triggered when a packet is received by the PHYs
+   * \param context the context
+   * \param p the received packet
+   * \param rxPowersW the received power per channel band in watts
+   */
+  void RxCallback (Ptr<const Packet> p, RxPowerWattPerChannelBand rxPowersW);
+
+  Ptr<ExtSpectrumWifiPhy> m_txPhy; ///< TX PHY
+  Ptr<ExtSpectrumWifiPhy> m_rxPhy; ///< RX PHY
+
+  uint16_t m_txChannelWidth; ///< TX channel width (MHz)
+  uint16_t m_rxChannelWidth; ///< RX channel width (MHz)
+};
+
+SpectrumWifiPhyFilterTest::SpectrumWifiPhyFilterTest ()
+  : TestCase ("SpectrumWifiPhy test RX filters"),
+    m_txChannelWidth (20),
+    m_rxChannelWidth (20)
+{
+}
+
+SpectrumWifiPhyFilterTest::SpectrumWifiPhyFilterTest (std::string name)
+  : TestCase (name)
+{
+}
+
+void
+SpectrumWifiPhyFilterTest::SendPpdu (void)
+{
+  WifiTxVector txVector = WifiTxVector (WifiPhy::GetHeMcs0 (), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, m_txChannelWidth, false, false);
+  Ptr<Packet> pkt = Create<Packet> (1000);
+  WifiMacHeader hdr;
+  hdr.SetType (WIFI_MAC_QOSDATA);
+  hdr.SetQosTid (0);
+  hdr.SetAddr1 (Mac48Address ("00:00:00:00:00:01"));
+  hdr.SetSequenceNumber (1);
+  Ptr<WifiPsdu> psdu = Create<WifiPsdu> (pkt, hdr);
+  m_txPhy->Send (WifiConstPsduMap ({std::make_pair (SU_STA_ID, psdu)}), txVector);
+}
+
+SpectrumWifiPhyFilterTest::~SpectrumWifiPhyFilterTest ()
+{
+  m_txPhy = 0;
+  m_rxPhy = 0;
+}
+
+void
+SpectrumWifiPhyFilterTest::RxCallback (Ptr<const Packet> p, RxPowerWattPerChannelBand rxPowersW)
+{
+  for (auto const& pair : rxPowersW)
+    {
+      NS_LOG_INFO ("band: (" << pair.first.first << ";" << pair.first.second << ") -> powerW=" << pair.second << " (" << WToDbm (pair.second) << " dBm)");
+    }
+
+  size_t numBands = rxPowersW.size ();
+  size_t expectedNumBands = std::max (1, (m_rxChannelWidth / 20));
+  expectedNumBands += (m_rxChannelWidth / 40);
+  expectedNumBands += (m_rxChannelWidth / 80);
+  expectedNumBands += (m_rxChannelWidth / 160);
+  if (m_rxChannelWidth == 20)
+    {
+      expectedNumBands += 9; /* RU_26_TONE */
+      expectedNumBands += 4; /* RU_52_TONE */
+      expectedNumBands += 2; /* RU_106_TONE */
+      expectedNumBands += 1; /* RU_242_TONE */
+    }
+  else if (m_rxChannelWidth == 40)
+    {
+      expectedNumBands += 18; /* RU_26_TONE */
+      expectedNumBands += 8; /* RU_52_TONE */
+      expectedNumBands += 4; /* RU_106_TONE */
+      expectedNumBands += 2; /* RU_242_TONE */
+      expectedNumBands += 1; /* RU_484_TONE */
+    }
+  else if (m_rxChannelWidth >= 80)
+    {
+      expectedNumBands += 37 * (m_rxChannelWidth / 80); /* RU_26_TONE */
+      expectedNumBands += 16 * (m_rxChannelWidth / 80); /* RU_52_TONE */
+      expectedNumBands += 8 * (m_rxChannelWidth / 80); /* RU_106_TONE */
+      expectedNumBands += 4 * (m_rxChannelWidth / 80); /* RU_242_TONE */
+      expectedNumBands += 2 * (m_rxChannelWidth / 80); /* RU_484_TONE */
+      expectedNumBands += 1 * (m_rxChannelWidth / 80); /* RU_996_TONE */
+      if (m_rxChannelWidth == 160)
+        {
+          ++expectedNumBands; /* RU_2x996_TONE */
+        }
+    }
+  NS_TEST_ASSERT_MSG_EQ (numBands, expectedNumBands, "Total number of bands handled by the receiver is incorrect");
+
+  uint16_t channelWidth = std::min (m_txChannelWidth, m_rxChannelWidth);
+  WifiSpectrumBand band = m_rxPhy->GetBand (channelWidth, 0);
+  auto it = rxPowersW.find (band);
+  NS_LOG_INFO ("powerW total band: " << it->second << " (" << WToDbm (it->second) << " dBm)");
+  int totalRxPower = static_cast<int> (WToDbm (it->second) + 0.5);
+  int expectedTotalRxPower;
+  if (m_txChannelWidth <= m_rxChannelWidth)
+    {
+      //PHY sends at 16 dBm, and since there is no loss, this should be the total power at the receiver.
+      expectedTotalRxPower = 16;
+    }
+  else
+    {
+      //Only a part of the transmitted power is received
+      expectedTotalRxPower = 16 - static_cast<int> (RatioToDb (m_txChannelWidth / m_rxChannelWidth));
+    }
+  NS_TEST_ASSERT_MSG_EQ (totalRxPower, expectedTotalRxPower, "Total received power is not correct");
+
+  if ((m_txChannelWidth <= m_rxChannelWidth) && (channelWidth >= 20))
+    {
+      band = m_rxPhy->GetBand (20, 0); //primary 20 MHz
+      it = rxPowersW.find (band);
+      NS_LOG_INFO ("powerW in primary 20 MHz channel: " << it->second << " (" << WToDbm (it->second) << " dBm)");
+      int rxPowerPrimaryChannel20 = static_cast<int> (WToDbm (it->second) + 0.5);
+      int expectedRxPowerPrimaryChannel20 = 16 - static_cast<int> (RatioToDb (channelWidth / 20));
+      NS_TEST_ASSERT_MSG_EQ (rxPowerPrimaryChannel20, expectedRxPowerPrimaryChannel20, "Received power in the primary 20 MHz band is not correct");
+    }
+}
+
+void
+SpectrumWifiPhyFilterTest::DoSetup (void)
+{
+  //WifiHelper::EnableLogComponents ();
+  //LogComponentEnable ("SpectrumWifiPhyBasicTest", LOG_LEVEL_ALL);
+
+  Ptr<MultiModelSpectrumChannel> spectrumChannel = CreateObject<MultiModelSpectrumChannel> ();
+  Ptr<FriisPropagationLossModel> lossModel = CreateObject<FriisPropagationLossModel> ();
+  lossModel->SetFrequency (5.180e9);
+  spectrumChannel->AddPropagationLossModel (lossModel);
+  Ptr<ConstantSpeedPropagationDelayModel> delayModel = CreateObject<ConstantSpeedPropagationDelayModel> ();
+  spectrumChannel->SetPropagationDelayModel (delayModel);
+  
+  Ptr<Node> txNode = CreateObject<Node> ();
+  Ptr<WifiNetDevice> txDev = CreateObject<WifiNetDevice> ();
+  m_txPhy = CreateObject<ExtSpectrumWifiPhy> ();
+  m_txPhy->CreateWifiSpectrumPhyInterface (txDev);
+  m_txPhy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  Ptr<ErrorRateModel> error = CreateObject<NistErrorRateModel> ();
+  m_txPhy->SetErrorRateModel (error);
+  m_txPhy->SetDevice (txDev);
+  m_txPhy->SetChannel (spectrumChannel);
+  Ptr<ConstantPositionMobilityModel> apMobility = CreateObject<ConstantPositionMobilityModel> ();
+  m_txPhy->SetMobility (apMobility);
+  txDev->SetPhy (m_txPhy);
+  txNode->AggregateObject (apMobility);
+  txNode->AddDevice (txDev);
+
+  Ptr<Node> rxNode = CreateObject<Node> ();
+  Ptr<WifiNetDevice> rxDev = CreateObject<WifiNetDevice> ();
+  m_rxPhy = CreateObject<ExtSpectrumWifiPhy> ();
+  m_rxPhy->CreateWifiSpectrumPhyInterface (rxDev);
+  m_rxPhy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211ax, WIFI_PHY_BAND_5GHZ);
+  m_rxPhy->SetErrorRateModel (error);
+  m_rxPhy->SetChannel (spectrumChannel);
+  Ptr<ConstantPositionMobilityModel> sta1Mobility = CreateObject<ConstantPositionMobilityModel> ();
+  m_rxPhy->SetMobility (sta1Mobility);
+  rxDev->SetPhy (m_rxPhy);
+  rxNode->AggregateObject (sta1Mobility);
+  rxNode->AddDevice (rxDev);
+  m_rxPhy->TraceConnectWithoutContext ("PhyRxBegin", MakeCallback (&SpectrumWifiPhyFilterTest::RxCallback, this));
+}
+
+void
+SpectrumWifiPhyFilterTest::RunOne (void)
+{
+  m_txPhy->SetChannelWidth (m_txChannelWidth);
+  uint16_t txFrequency;
+  switch (m_txChannelWidth)
+    {
+    case 20:
+    default:
+      txFrequency = 5180;
+      break;
+    case 40:
+      txFrequency = 5190;
+      break;
+    case 80:
+      txFrequency = 5210;
+      break;
+    case 160:
+      txFrequency = 5250;
+      break;
+    }
+  m_txPhy->SetFrequency (txFrequency);
+
+  m_rxPhy->SetChannelWidth (m_rxChannelWidth);
+  uint16_t rxFrequency;
+  switch (m_rxChannelWidth)
+    {
+    case 20:
+    default:
+      rxFrequency = 5180;
+      break;
+    case 40:
+      rxFrequency = 5190;
+      break;
+    case 80:
+      rxFrequency = 5210;
+      break;
+    case 160:
+      rxFrequency = 5250;
+      break;
+    }
+  m_rxPhy->SetFrequency (rxFrequency);
+
+  Simulator::Schedule (Seconds (1), &SpectrumWifiPhyFilterTest::SendPpdu, this);
+  
+  Simulator::Run ();
+}
+
+void
+SpectrumWifiPhyFilterTest::DoRun (void)
+{
+  m_txChannelWidth = 20;
+  m_rxChannelWidth = 20;
+  RunOne ();
+
+  m_txChannelWidth = 40;
+  m_rxChannelWidth = 40;
+  RunOne ();
+
+  m_txChannelWidth = 80;
+  m_rxChannelWidth = 80;
+  RunOne ();
+
+  m_txChannelWidth = 160;
+  m_rxChannelWidth = 160;
+  RunOne ();
+
+  m_txChannelWidth = 20;
+  m_rxChannelWidth = 40;
+  RunOne ();
+
+  m_txChannelWidth = 20;
+  m_rxChannelWidth = 80;
+  RunOne ();
+
+  m_txChannelWidth = 40;
+  m_rxChannelWidth = 80;
+  RunOne ();
+
+  m_txChannelWidth = 20;
+  m_rxChannelWidth = 160;
+  RunOne ();
+
+  m_txChannelWidth = 40;
+  m_rxChannelWidth = 160;
+  RunOne ();
+
+  m_txChannelWidth = 80;
+  m_rxChannelWidth = 160;
+  RunOne ();
+
+  m_txChannelWidth = 40;
+  m_rxChannelWidth = 20;
+  RunOne ();
+
+  m_txChannelWidth = 80;
+  m_rxChannelWidth = 20;
+  RunOne ();
+
+  m_txChannelWidth = 80;
+  m_rxChannelWidth = 40;
+  RunOne ();
+
+  m_txChannelWidth = 160;
+  m_rxChannelWidth = 20;
+  RunOne ();
+
+  m_txChannelWidth = 160;
+  m_rxChannelWidth = 40;
+  RunOne ();
+
+  m_txChannelWidth = 160;
+  m_rxChannelWidth = 80;
+  RunOne ();
+
+  Simulator::Destroy ();
+}
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * \brief Spectrum Wifi Phy Test Suite
  */
 class SpectrumWifiPhyTestSuite : public TestSuite
@@ -322,6 +644,7 @@
 {
   AddTestCase (new SpectrumWifiPhyBasicTest, TestCase::QUICK);
   AddTestCase (new SpectrumWifiPhyListenerTest, TestCase::QUICK);
+  AddTestCase (new SpectrumWifiPhyFilterTest, TestCase::QUICK);
 }
 
 static SpectrumWifiPhyTestSuite spectrumWifiPhyTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/test/tx-duration-test.cc ns-3.33/src/wifi/test/tx-duration-test.cc
--- ns-3.32/src/wifi/test/tx-duration-test.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/test/tx-duration-test.cc	2021-01-09 10:19:23.000000000 -0800
@@ -20,8 +20,13 @@
  */
 
 #include "ns3/log.h"
+#include "ns3/simulator.h"
 #include "ns3/test.h"
 #include "ns3/yans-wifi-phy.h"
+#include "ns3/he-ru.h"
+#include "ns3/wifi-psdu.h"
+#include "ns3/packet.h"
+#include <numeric>
 
 using namespace ns3;
 
@@ -72,6 +77,38 @@
    */
   bool CheckTxDuration (uint32_t size, WifiMode payloadMode, uint16_t channelWidth, uint16_t guardInterval, WifiPreamble preamble, Time knownDuration);
 
+  /**
+   * Check if the overall Tx duration returned by WifiPhy for a HE MU PPDU
+   * corresponds to a known value
+   *
+   * @param sizes the list of PSDU sizes for each station in octets
+   * @param userInfos the list of HE MU specific user transmission parameters
+   * @param channelWidth the channel width used for the transmission (in MHz)
+   * @param guardInterval the guard interval duration used for the transmission (in nanoseconds)
+   * @param knownDuration the known duration value of the transmission
+   *
+   * @return true if values correspond, false otherwise
+   */
+  static bool CheckHeMuTxDuration (std::list<uint32_t> sizes, std::list<HeMuUserInfo> userInfos,
+                                   uint16_t channelWidth, uint16_t guardInterval,
+                                   Time knownDuration);
+
+  /**
+   * Calculate the overall Tx duration returned by WifiPhy for list of sizes.
+   * A map of WifiPsdu indexed by STA-ID is built using the provided lists
+   * and handed over to the corresponding SU/MU WifiPhy Tx duration computing
+   * method.
+   * Note that provided lists should be of same size.
+   *
+   * @param sizes the list of PSDU sizes for each station in octets
+   * @param staIds the list of STA-IDs of each station
+   * @param txVector the TXVECTOR used for the transmission of the PPDU
+   * @param band the selected wifi PHY band
+   *
+   * @return the overall Tx duration for the list of sizes (SU or MU PPDU)
+   */
+  static Time CalculateTxDurationUsingList (std::list<uint32_t> sizes, std::list<uint16_t> staIds,
+                                            WifiTxVector txVector, WifiPhyBand band);
 };
 
 TxDurationTest::TxDurationTest ()
@@ -159,7 +196,9 @@
       band = WIFI_PHY_BAND_5GHZ;
     }
   Time calculatedDuration = phy->CalculateTxDuration (size, txVector, band);
-  if (calculatedDuration != knownDuration)
+  Time calculatedDurationUsingList = CalculateTxDurationUsingList (std::list<uint32_t> {size}, std::list<uint16_t> {SU_STA_ID},
+                                                                   txVector, band);
+  if (calculatedDuration != knownDuration || calculatedDuration != calculatedDurationUsingList)
     {
       std::cerr << "size=" << size
                 << " mode=" << payloadMode
@@ -169,6 +208,7 @@
                 << " preamble=" << preamble
                 << " known=" << knownDuration
                 << " calculated=" << calculatedDuration
+                << " calculatedUsingList=" << calculatedDurationUsingList
                 << std::endl;
       return false;
     }
@@ -177,8 +217,10 @@
       //Durations vary depending on frequency; test also 2.4 GHz (bug 1971)
       band = WIFI_PHY_BAND_2_4GHZ;
       calculatedDuration = phy->CalculateTxDuration (size, txVector, band);
+      calculatedDurationUsingList = CalculateTxDurationUsingList (std::list<uint32_t> {size}, std::list<uint16_t> {SU_STA_ID},
+                                                                  txVector, band);
       knownDuration += MicroSeconds (6);
-      if (calculatedDuration != knownDuration)
+      if (calculatedDuration != knownDuration || calculatedDuration != calculatedDurationUsingList)
         {
           std::cerr << "size=" << size
                     << " mode=" << payloadMode
@@ -188,6 +230,7 @@
                     << " preamble=" << preamble
                     << " known=" << knownDuration
                     << " calculated=" << calculatedDuration
+                    << " calculatedUsingList=" << calculatedDurationUsingList
                     << std::endl;
           return false;
         }
@@ -195,6 +238,89 @@
   return true;
 }
 
+bool
+TxDurationTest::CheckHeMuTxDuration (std::list<uint32_t> sizes, std::list<HeMuUserInfo> userInfos,
+                                     uint16_t channelWidth, uint16_t guardInterval,
+                                     Time knownDuration)
+{
+  NS_ASSERT (sizes.size () == userInfos.size () && sizes.size () > 1);
+  NS_ABORT_MSG_IF (channelWidth < std::accumulate (std::begin (userInfos), std::end (userInfos), 0,
+                                                   [](const uint16_t prevBw, const HeMuUserInfo &info)
+                                                   { return prevBw + HeRu::GetBandwidth (info.ru.ruType); }),
+                   "Cannot accommodate all the RUs in the provided band"); //MU-MIMO (for which allocations use the same RU) is not supported
+  WifiTxVector txVector;
+  txVector.SetPreambleType (WIFI_PREAMBLE_HE_MU);
+  txVector.SetChannelWidth (channelWidth);
+  txVector.SetGuardInterval (guardInterval);
+  txVector.SetStbc (0);
+  txVector.SetNess (0);
+  std::list<uint16_t> staIds;
+  uint16_t staId = 1;
+  for (const auto & userInfo : userInfos)
+    {
+      txVector.SetHeMuUserInfo (staId, userInfo);
+      staIds.push_back (staId++);
+    }
+  Ptr<YansWifiPhy> phy = CreateObject<YansWifiPhy> ();
+  std::list<WifiPhyBand> testedBands {WIFI_PHY_BAND_5GHZ, WIFI_PHY_BAND_2_4GHZ}; //Durations vary depending on frequency; test also 2.4 GHz (bug 1971)
+  for (auto & testedBand : testedBands)
+    {
+      if (testedBand == WIFI_PHY_BAND_2_4GHZ)
+        {
+          knownDuration += MicroSeconds (6);
+        }
+      Time calculatedDuration = NanoSeconds (0);
+      uint32_t longuestSize = 0;
+      auto iterStaId = staIds.begin ();
+      for (auto & size : sizes)
+        {
+          Time ppduDurationForSta = phy->CalculateTxDuration (size, txVector, testedBand, *iterStaId);
+          if (ppduDurationForSta > calculatedDuration)
+            {
+              calculatedDuration = ppduDurationForSta;
+              staId = *iterStaId;
+              longuestSize = size;
+            }
+          ++iterStaId;
+        }
+      Time calculatedDurationUsingList = CalculateTxDurationUsingList (sizes, staIds, txVector, testedBand);
+      if (calculatedDuration != knownDuration || calculatedDuration != calculatedDurationUsingList)
+        {
+          std::cerr << "size=" << longuestSize
+                    << " band=" << testedBand
+                    << " staId=" << staId
+                    << " nss=" << +txVector.GetNss (staId)
+                    << " mode=" << txVector.GetMode (staId)
+                    << " channelWidth=" << channelWidth
+                    << " guardInterval=" << guardInterval
+                    << " datarate=" << txVector.GetMode (staId).GetDataRate (channelWidth, guardInterval, txVector.GetNss (staId))
+                    << " known=" << knownDuration
+                    << " calculated=" << calculatedDuration
+                    << " calculatedUsingList=" << calculatedDurationUsingList
+                    << std::endl;
+          return false;
+        }
+    }
+  return true;
+}
+
+Time
+TxDurationTest::CalculateTxDurationUsingList (std::list<uint32_t> sizes, std::list<uint16_t> staIds,
+                                              WifiTxVector txVector, WifiPhyBand band)
+{
+  NS_ASSERT (sizes.size () == staIds.size ());
+  WifiConstPsduMap psduMap;
+  auto itStaId = staIds.begin ();
+  WifiMacHeader hdr;
+  hdr.SetType (WIFI_MAC_CTL_ACK); //so that size may not be empty while being as short as possible
+  for (auto & size : sizes)
+    {
+      // MAC header and FCS are to deduce from size
+      psduMap[*itStaId++] = Create<WifiPsdu> (Create<Packet> (size - hdr.GetSerializedSize () - 4), hdr);
+    }
+  return WifiPhy::CalculateTxDuration (psduMap, txVector, band);
+}
+
 void
 TxDurationTest::DoRun (void)
 {
@@ -345,7 +471,7 @@
 
   NS_TEST_EXPECT_MSG_EQ (retval, true, "an 802.11ac duration failed");
 
-  //802.11ax durations
+  //802.11ax SU durations
   retval = retval
     && CheckTxDuration (1536, WifiPhy::GetHeMcs0 (), 20, 800, WIFI_PREAMBLE_HE_SU, NanoSeconds (1485600))
     && CheckTxDuration (76, WifiPhy::GetHeMcs0 (), 20, 800, WIFI_PREAMBLE_HE_SU, NanoSeconds (125600))
@@ -420,7 +546,29 @@
     && CheckTxDuration (76, WifiPhy::GetHeMcs11 (), 160, 3200, WIFI_PREAMBLE_HE_SU, MicroSeconds (60))
     && CheckTxDuration (14, WifiPhy::GetHeMcs11 (), 160, 3200, WIFI_PREAMBLE_HE_SU, MicroSeconds (60));
 
-  NS_TEST_EXPECT_MSG_EQ (retval, true, "an 802.11ax duration failed");
+  NS_TEST_EXPECT_MSG_EQ (retval, true, "an 802.11ax SU duration failed");
+
+  //802.11ax MU durations
+  retval = retval
+    && CheckHeMuTxDuration (std::list<uint32_t> {1536,
+                                                 1536},
+                            std::list<HeMuUserInfo> { {{true, HeRu::RU_242_TONE, 1}, WifiPhy::GetHeMcs0 (), 1},
+                                                      {{true, HeRu::RU_242_TONE, 2}, WifiPhy::GetHeMcs0 (), 1} },
+                            40, 800, NanoSeconds (1489600)) //equivalent to HE_SU for 20 MHz with extra HE-SIG-B (i.e. 4 us)
+  && CheckHeMuTxDuration (std::list<uint32_t> {1536,
+                                               1536},
+                          std::list<HeMuUserInfo> { {{true, HeRu::RU_242_TONE, 1}, WifiPhy::GetHeMcs1 (), 1},
+                                                    {{true, HeRu::RU_242_TONE, 2}, WifiPhy::GetHeMcs0 (), 1} },
+                          40, 800, NanoSeconds (1489600)) //shouldn't change if first PSDU is shorter
+  && CheckHeMuTxDuration (std::list<uint32_t> {1536,
+                                               76},
+                          std::list<HeMuUserInfo> { {{true, HeRu::RU_242_TONE, 1}, WifiPhy::GetHeMcs0 (), 1},
+                                                    {{true, HeRu::RU_242_TONE, 2}, WifiPhy::GetHeMcs0 (), 1} },
+                          40, 800, NanoSeconds (1489600));
+
+  NS_TEST_EXPECT_MSG_EQ (retval, true, "an 802.11ax MU duration failed");
+
+  Simulator::Destroy ();
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/test/wifi-aggregation-test.cc ns-3.33/src/wifi/test/wifi-aggregation-test.cc
--- ns-3.32/src/wifi/test/wifi-aggregation-test.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/test/wifi-aggregation-test.cc	2021-01-09 10:19:23.000000000 -0800
@@ -654,11 +654,11 @@
   void NotifyMacTransmit (Ptr<const Packet> packet);
   /**
    * Callback invoked when the sender MAC passes a PSDU(s) to the PHY
-   * \param psdu the PSDU
+   * \param psduMap the PSDU map
    * \param txVector the TX vector
    * \param txPowerW the transmit power in Watts
    */
-  void NotifyPsduForwardedDown (Ptr<const WifiPsdu> psdu, WifiTxVector txVector, double txPowerW);
+  void NotifyPsduForwardedDown (WifiConstPsduMap psduMap, WifiTxVector txVector, double txPowerW);
   /**
    * Callback invoked when the receiver MAC forwards a packet up to the upper layer
    * \param p the packet
@@ -682,16 +682,19 @@
 }
 
 void
-PreservePacketsInAmpdus::NotifyPsduForwardedDown (Ptr<const WifiPsdu> psdu, WifiTxVector txVector, double txPowerW)
+PreservePacketsInAmpdus::NotifyPsduForwardedDown (WifiConstPsduMap psduMap, WifiTxVector txVector, double txPowerW)
 {
-  if (!psdu->GetHeader (0).IsQosData ())
+  NS_TEST_EXPECT_MSG_EQ ((psduMap.size () == 1 && psduMap.begin ()->first == SU_STA_ID),
+                         true, "No DL MU PPDU expected");
+
+  if (!psduMap[SU_STA_ID]->GetHeader (0).IsQosData ())
     {
       return;
     }
 
-  m_nMpdus.push_back (psdu->GetNMpdus ());
+  m_nMpdus.push_back (psduMap[SU_STA_ID]->GetNMpdus ());
 
-  for (auto& mpdu : *PeekPointer (psdu))
+  for (auto& mpdu : *PeekPointer (psduMap[SU_STA_ID]))
     {
       std::size_t dist = std::distance (mpdu->begin (), mpdu->end ());
       // the list of aggregated MSDUs is empty if the MPDU includes a non-aggregated MSDU
@@ -717,7 +720,7 @@
   wifiApNode.Create (1);
 
   YansWifiChannelHelper channel = YansWifiChannelHelper::Default ();
-  YansWifiPhyHelper phy = YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper phy;
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
